<i18n>
{
  "fr": {
    "label-1": "Catégorie",
    "label-2": "Sous catégorie",
    "label-3": "Sous sous catégorie",
    "label-4": "Unité",
    "label-5": "Nom du facteur dans la Base Carbone®",
    "label-6": "Nom",
    "label-7": "Année",
    "label-8": "Décomposition",
    "label-9": "Total",
    "label-10": "Autres Gaz",
    "label-11": "Unité eqCO2",
    "label-12": "Facteur eqCO2",
    "label-13": "Incertitude",
    "label-14": "Groupe d'incertitude"
  },
  "en": {
    "label-1": "Category",
    "label-2": "Sub-category",
    "label-3": "Sub-sub-category",
    "label-4": "Unit",
    "label-5": "Factor name in the Base Carbone®",
    "label-6": "Name",
    "label-7": "Year",
    "label-8": "Decomposition",
    "label-9": "Total",
    "label-10": "Other gases",
    "label-11": "CO2eq unit",
    "label-12": "CO2eq factor",
    "label-13": "Uncertainty",
    "label-14": "Uncertainty group"
  }
}
</i18n>

<template>
  <b-table
    :data="factors"
    ref="table"
    detailed
    hoverable
    :sticky-header="true"
    narrowed
    striped
    :has-detailed-visible="hasDecomposition"
    icon-pack="sui"
    custom-detail-row
    :show-detail-icon="true"
  >
    <b-table-column v-slot="props" :label="$t('label-1')">
      {{ $t(props.row.category) }}
    </b-table-column>
    <b-table-column v-slot="props" :label="$t('label-2')">
      {{ $t(props.row.subcategory) }}
    </b-table-column>
    <b-table-column :label="$t('label-3')">
      <template v-slot="props">
        <span v-if="$t(props.row.subsubcategory).length < 20">
          {{ $t(props.row.subsubcategory) }}
        </span>
        <span v-else>
          <b-tooltip multilined :label="$t(props.row.subsubcategory)" type="is-info">
            {{ $t(props.row.subsubcategory) | nomTronque(20) }}
          </b-tooltip>
        </span>
      </template>
    </b-table-column>
    <b-table-column v-slot="props" :label="$t('label-4')">
      {{ props.row.unit }}
    </b-table-column>
    <b-table-column>
      <template v-slot:header>
        {{ $t('label-6') }}
      </template>
      <template v-slot="props">
        <span v-if="getDescription(props.row).length < 20">
          {{ getDescription(props.row) }}
        </span>
        <span v-else>
          <b-tooltip multilined :label="getDescription(props.row)" type="is-info">
            {{ getDescription(props.row) | nomTronque(20) }}
          </b-tooltip>
        </span>
      </template>
    </b-table-column>
    <b-table-column v-slot="props" :label="$t('label-7')" >
      {{ getLastYear(props.row) }}
    </b-table-column>
    <b-table-column :label="$t('label-8')" >
      {{ $t('label-9') }}
    </b-table-column>
    <b-table-column numeric v-slot="props" label="CO2">
      {{ props.row.decomposition[getLastYear(props.row)].total.co2 }}
    </b-table-column>
    <b-table-column numeric v-slot="props" label="CH4">
      {{ props.row.decomposition[getLastYear(props.row)].total.ch4 }}
    </b-table-column>
    <b-table-column numeric v-slot="props" label="N2O">
      {{ props.row.decomposition[getLastYear(props.row)].total.n2o }}
    </b-table-column>
    <b-table-column numeric v-slot="props" :label="$t('label-10')" >
      {{ props.row.decomposition[getLastYear(props.row)].total.others }}
    </b-table-column>
    <b-table-column v-slot="props" :label="$t('label-11')" >
      {{ props.row.decomposition[getLastYear(props.row)].total.unit }}
    </b-table-column>
    <b-table-column numeric v-slot="props" :label="$t('label-12')">
      {{ props.row.decomposition[getLastYear(props.row)].total.total }}
    </b-table-column>
    <b-table-column numeric v-slot="props" :label="$t('label-14')" >
      {{ props.row.group }}
    </b-table-column>
    <b-table-column numeric v-slot="props" :label="$t('label-13')" >
      {{ props.row.decomposition[getLastYear(props.row)].total.uncertainty * 100 }} %
    </b-table-column>
    <template slot="detail" slot-scope="props">
      <tr v-for="(dec,index) in Object.keys(props.row.decomposition[getLastYear(props.row)])" :key="Math.floor(Math.random() * 100000000) + index">
        <td v-if="index==1" :rowspan="Object.keys(props.row.decomposition[getLastYear(props.row)]).length-1" colspan="7" style="border-right:1px solid #dbdbdb"></td>
        <td v-if="index>0">{{ $t(dec) }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].co2 }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].ch4 }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].n2o }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].others }}</td>
        <td v-if="index>0">{{ props.row.decomposition[getLastYear(props.row)][dec].unit }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].total }}</td>
        <td v-if="index>0" class="has-text-right">{{ props.row.decomposition[getLastYear(props.row)][dec].uncertainty }}</td>
      </tr>
    </template>
  </b-table>
</template>

<script>
export default {
  name: 'EmissionsFactorsTable',
  props: {
    factors: {
      type: Array,
      default: function () {
        return []
      }
    }
  },
  methods: {
    hasDecomposition: function (row) {
      return (Object.keys(row.decomposition[this.getLastYear(row)]).length > 1)
    },
    getLastYear: function (row) {
      return Math.max(...Object.keys(row.decomposition).map(val => parseInt(val)))
    },
    getDescription: function (factor) {
      return factor['description_' + this.$i18n.locale.toUpperCase()]
    }
  }
}
</script>

<style>
.b-table .table-wrapper.has-sticky-header {
  height: 560px !important;
  overflow-y: auto;
}
</style>
